//!--------- Create dialog windows -------------!//

gpointer Browser_Settings_Dialog(GtkMenuItem *Item, gpointer What)
{
	GtkWidget *Dialog;
	GtkWidget *Button;
//	GtkWidget *HBox;
	GtkWidget *Frame;
	gint Response; 
	
	Dialog = gtk_dialog_new_with_buttons("Browser Settings", GTK_WINDOW(Main_Window), GTK_DIALOG_MODAL, GTK_STOCK_APPLY, GTK_RESPONSE_APPLY, NULL);
	
	Button = gtk_dialog_add_button(GTK_DIALOG(Dialog), GTK_STOCK_CLOSE, GTK_RESPONSE_CLOSE);
	gtk_widget_grab_focus(Button);
	
	Frame = gtk_frame_new("Connection details");
	gtk_container_add(GTK_CONTAINER(GTK_DIALOG(Dialog)->vbox), Frame);
	
	Frame = gtk_frame_new("Interface");
	gtk_container_add(GTK_CONTAINER(GTK_DIALOG(Dialog)->vbox), Frame);
	
	gtk_widget_show_all(Dialog);
	Response = gtk_dialog_run(GTK_DIALOG(Dialog));
	
	if (Response == GTK_RESPONSE_APPLY){
	}
	gtk_widget_destroy(Dialog);
	return NULL;
}


gpointer Searcher_Settings_Dialog(GtkMenuItem *Item, gpointer What)
{
	GtkWidget *Dialog;
	GtkWidget *Button;
	GtkWidget *Frame;
	GtkWidget *VBox;	
	GtkWidget *HBox;
	GtkWidget *Label;
	gint Response;
	gint Active;
	guint num = 0; 
	
	Dialog = gtk_dialog_new_with_buttons("Searcher Settings", GTK_WINDOW(Main_Window), GTK_DIALOG_MODAL, GTK_STOCK_APPLY, GTK_RESPONSE_APPLY, NULL);
	
	Button = gtk_dialog_add_button(GTK_DIALOG(Dialog), GTK_STOCK_CLOSE, GTK_RESPONSE_CLOSE);
	gtk_widget_grab_focus(Button);
	
	Frame = gtk_frame_new("Search Masks");
	gtk_container_set_border_width(GTK_CONTAINER(Frame), 5);
	gtk_box_pack_start(GTK_BOX(GTK_DIALOG(Dialog)->vbox), Frame, FALSE, FALSE, 0);
	
	VBox= gtk_vbox_new(FALSE, 5);
	gtk_container_set_border_width(GTK_CONTAINER(VBox), 5);
	gtk_container_add(GTK_CONTAINER(Frame), VBox);
	
	HBox = gtk_hbox_new(FALSE, 5);
	gtk_box_pack_start(GTK_BOX(VBox), HBox, FALSE, FALSE, 0);
	
	Label = gtk_label_new("Record name:");
	gtk_box_pack_start(GTK_BOX(HBox), Label, FALSE, FALSE, 0);
	
	Mask_Name = gtk_combo_box_new_text();
	gtk_box_pack_start(GTK_BOX(HBox), Mask_Name, TRUE, TRUE, 0);
	g_signal_connect(Mask_Name, "changed", G_CALLBACK(Call_Activate_Mask), NULL);

	HBox = gtk_hbox_new(FALSE, 5);	
	gtk_box_pack_start(GTK_BOX(VBox), HBox, FALSE, FALSE, 0);

	Label = gtk_label_new("Extensions:\n(separated by comas)");
	gtk_box_pack_start(GTK_BOX(HBox), Label, FALSE, FALSE, 0);
	
	Mask_Extensions = gtk_entry_new();
	gtk_box_pack_start(GTK_BOX(HBox), Mask_Extensions, TRUE, TRUE, 0);

	HBox = gtk_hbox_new(FALSE, 5);
	gtk_box_pack_start(GTK_BOX(VBox), HBox, FALSE, FALSE, 0);

	Label = gtk_label_new("File size between:");
	gtk_box_pack_start(GTK_BOX(HBox), Label, FALSE, FALSE, 0);
	
	Mask_MinSize = gtk_entry_new();
	gtk_entry_set_width_chars(GTK_ENTRY(Mask_MinSize), 5);
	gtk_box_pack_start(GTK_BOX(HBox), Mask_MinSize, TRUE, TRUE, 0);

	Label = gtk_label_new("and");
	gtk_box_pack_start(GTK_BOX(HBox), Label, FALSE, FALSE, 0);
		
	Mask_MaxSize = gtk_entry_new();
	gtk_entry_set_width_chars(GTK_ENTRY(Mask_MaxSize), 5);
	gtk_box_pack_start(GTK_BOX(HBox), Mask_MaxSize, TRUE, TRUE, 0);

	Mask_Metric = gtk_entry_new();
	gtk_entry_set_width_chars(GTK_ENTRY(Mask_Metric), 9);
	gtk_box_pack_start(GTK_BOX(HBox), Mask_Metric, FALSE, FALSE, 0);

	HBox = gtk_hbox_new(FALSE, 2);
	gtk_box_pack_start(GTK_BOX(VBox), HBox, FALSE, FALSE, 0);

	Label = gtk_label_new("Search in shares consist:\n(separated by comas)");
	gtk_box_pack_start(GTK_BOX(HBox), Label, FALSE, FALSE, 0);
	
	Mask_Shares = gtk_entry_new();
	gtk_box_pack_start(GTK_BOX(HBox), Mask_Shares, TRUE, TRUE, 0);

	HBox = gtk_hbox_new(FALSE, 2);
	gtk_box_pack_start(GTK_BOX(VBox), HBox, FALSE, FALSE, 0);
	
	Button = gtk_button_new_from_stock(GTK_STOCK_NEW);
//	g_signal_connect(Button, "clicked", G_CALLBACK(New_Record), "New Record");
	gtk_box_pack_end(GTK_BOX(HBox), Button, FALSE, FALSE, 0);
	
	while (Masks[num].Name != NULL){
		gtk_combo_box_insert_text(GTK_COMBO_BOX(Mask_Name), num, Masks[num].Name);
		num++;
	}	
	Set_Active_Mask(0);
	
	gtk_widget_show_all(Dialog);
	Response = gtk_dialog_run(GTK_DIALOG(Dialog));
	if (Response == GTK_RESPONSE_APPLY){
		Active = gtk_combo_box_get_active(GTK_COMBO_BOX(Mask_Name)); 
		g_key_file_set_string(InitFile, Masks[Active].Name, "Extensions", gtk_entry_get_text(GTK_ENTRY(Mask_Extensions)));
		g_key_file_set_string(InitFile, Masks[Active].Name, "MinSize", gtk_entry_get_text(GTK_ENTRY(Mask_MinSize)));
		g_key_file_set_string(InitFile, Masks[Active].Name, "MaxSize", gtk_entry_get_text(GTK_ENTRY(Mask_MaxSize)));
		g_key_file_set_string(InitFile, Masks[Active].Name, "Shares", gtk_entry_get_text(GTK_ENTRY(Mask_Shares)));
		g_key_file_set_string(InitFile, Masks[Active].Name, "Metric", gtk_entry_get_text(GTK_ENTRY(Mask_Metric)));
		Masks[Active].Extensions = g_key_file_get_string(InitFile, Masks[Active].Name, "Extensions", NULL);
		Masks[Active].MinSize = g_key_file_get_string(InitFile, Masks[Active].Name, "MinSize", NULL);
		Masks[Active].MaxSize = g_key_file_get_string(InitFile, Masks[Active].Name, "MaxSize", NULL);
		Masks[Active].Metric = g_key_file_get_string(InitFile, Masks[Active].Name, "Metric", NULL);
		Masks[Active].Shares = g_key_file_get_string(InitFile, Masks[Active].Name, "Shares", NULL); 
		config_save();
	}

	gtk_widget_destroy(Dialog);
	return NULL;
}

gpointer Downloader_Settings_Dialog(GtkMenuItem *Item, gpointer What)
{
	GtkWidget *Dialog;
	GtkWidget *Button;
	GtkWidget *Frame;
	GtkWidget *VBox;	
	GtkWidget *HBox;
	GtkWidget *Label;
	gint Response; 
	
	Dialog = gtk_dialog_new_with_buttons("Downloader Settings", GTK_WINDOW(Main_Window), GTK_DIALOG_MODAL, GTK_STOCK_APPLY, GTK_RESPONSE_APPLY, NULL);
	
	Button = gtk_dialog_add_button(GTK_DIALOG(Dialog), GTK_STOCK_CLOSE, GTK_RESPONSE_CLOSE);
	gtk_widget_grab_focus(Button);
	
	Frame = gtk_frame_new("Saving options");
	gtk_container_set_border_width(GTK_CONTAINER(Frame), 5);
	gtk_container_add(GTK_CONTAINER(GTK_DIALOG(Dialog)->vbox), Frame);
	
	VBox= gtk_vbox_new(FALSE, 5);
	gtk_container_set_border_width(GTK_CONTAINER(VBox), 5);
	gtk_container_add(GTK_CONTAINER(Frame), VBox);
	
	HBox = gtk_hbox_new(FALSE, 5);
	gtk_box_pack_start(GTK_BOX(VBox), HBox, FALSE, FALSE, 0);
	
	Label = gtk_label_new("Save to folder:");
	gtk_box_pack_start(GTK_BOX(HBox), Label, FALSE, FALSE, 0);
	
	SEARCHER_SAVE_FOLDER = gtk_entry_new();
	if (Save_Folder != NULL) gtk_entry_set_text(GTK_ENTRY(SEARCHER_SAVE_FOLDER), Save_Folder);
	gtk_box_pack_start(GTK_BOX(HBox), SEARCHER_SAVE_FOLDER, TRUE, TRUE, 0);

	gtk_widget_show_all(Dialog);
	Response = gtk_dialog_run(GTK_DIALOG(Dialog));
	
	if (Response == GTK_RESPONSE_APPLY){
		g_key_file_set_string(InitFile, "Searcher", "Save_Folder", gtk_entry_get_text(GTK_ENTRY(SEARCHER_SAVE_FOLDER)));
		Save_Folder = g_key_file_get_string(InitFile, "Searcher", "Save_Folder", NULL);
		config_save();
	}
	
	gtk_widget_destroy(Dialog);
	return NULL;
}

gpointer Global_Settings_Dialog(GtkMenuItem *Item, gpointer What)
{
	GtkWidget *Dialog;
	GtkWidget *Button;
	GtkWidget *Frame;
	GtkWidget *VBox;
	GtkWidget *HBox;
	GtkWidget *Label;
	gint Response;
	
	Dialog = gtk_dialog_new_with_buttons("Global Settings", GTK_WINDOW(Main_Window), GTK_DIALOG_MODAL, GTK_STOCK_APPLY, GTK_RESPONSE_APPLY, NULL);
	
	Button = gtk_dialog_add_button(GTK_DIALOG(Dialog), GTK_STOCK_CLOSE, GTK_RESPONSE_CLOSE);
	gtk_widget_grab_focus(Button);
	
	Frame = gtk_frame_new("Connection details");
	gtk_container_set_border_width(GTK_CONTAINER(Frame), 5);
	gtk_box_pack_start(GTK_BOX(GTK_DIALOG(Dialog)->vbox), Frame, FALSE, FALSE, 0);
	
	VBox= gtk_vbox_new(FALSE, 5);
	gtk_container_set_border_width(GTK_CONTAINER(VBox), 5);
	gtk_container_add(GTK_CONTAINER(Frame), VBox);

	HBox= gtk_hbox_new(FALSE, 5);
	gtk_box_pack_start(GTK_BOX(VBox), HBox, FALSE, FALSE, 0);
	
	Label = gtk_label_new("Login");
	gtk_box_pack_start(GTK_BOX(HBox), Label, FALSE, FALSE, 0);
	
	GLOBAL_LOGIN = gtk_entry_new();
	gtk_entry_set_text(GTK_ENTRY(GLOBAL_LOGIN), Login);	
	gtk_box_pack_start(GTK_BOX(HBox), GLOBAL_LOGIN, TRUE, TRUE, 0);

	HBox= gtk_hbox_new(FALSE, 5);
	gtk_box_pack_start(GTK_BOX(VBox), HBox, FALSE, FALSE, 0);
	
	Label = gtk_label_new("Password");
	gtk_box_pack_start(GTK_BOX(HBox), Label, FALSE, FALSE, 0);
	
	GLOBAL_PASSWORD = gtk_entry_new();
	gtk_entry_set_visibility(GTK_ENTRY(GLOBAL_PASSWORD), FALSE);
	gtk_entry_set_text(GTK_ENTRY(GLOBAL_PASSWORD), Password);
	gtk_box_pack_start(GTK_BOX(HBox), GLOBAL_PASSWORD, TRUE, TRUE, 0);

	HBox= gtk_hbox_new(FALSE, 5);
	gtk_box_pack_start(GTK_BOX(VBox), HBox, FALSE, FALSE, 0);
	
	Label = gtk_label_new("Samba Encoding");
	gtk_box_pack_start(GTK_BOX(HBox), Label, FALSE, FALSE, 0);
	
	GLOBAL_SMB_ENCODING = gtk_entry_new();
	gtk_entry_set_text(GTK_ENTRY(GLOBAL_SMB_ENCODING), Samba_Filename_Encoding);
	gtk_box_pack_start(GTK_BOX(HBox), GLOBAL_SMB_ENCODING, TRUE, TRUE, 0);
	
	HBox= gtk_hbox_new(FALSE, 5);
	gtk_box_pack_start(GTK_BOX(VBox), HBox, FALSE, FALSE, 0);
	
	Label = gtk_label_new("Filename Encoding");
	gtk_box_pack_start(GTK_BOX(HBox), Label, FALSE, FALSE, 0);
	
	GLOBAL_FILE_ENCODING = gtk_entry_new();
	gtk_entry_set_text(GTK_ENTRY(GLOBAL_FILE_ENCODING), System_Filename_Encoding);	
	gtk_box_pack_start(GTK_BOX(HBox), GLOBAL_FILE_ENCODING, TRUE, TRUE, 0);
	
	gtk_widget_show_all(Dialog);
	Response = gtk_dialog_run(GTK_DIALOG(Dialog));
	
	if (Response == GTK_RESPONSE_APPLY){
		g_key_file_set_string(InitFile, "Global", "Sys_Encoding", gtk_entry_get_text(GTK_ENTRY(GLOBAL_FILE_ENCODING)));
		g_key_file_set_string(InitFile, "Global", "Smb_Encoding", gtk_entry_get_text(GTK_ENTRY(GLOBAL_SMB_ENCODING)));
		System_Filename_Encoding = g_key_file_get_string(InitFile, "Global", "Sys_Encoding", NULL);
		Samba_Filename_Encoding = g_key_file_get_string(InitFile, "Global", "Smb_Encoding", NULL);
		config_save();
	}
	gtk_widget_destroy(Dialog);
	return NULL;
}

gpointer About_Dialog(GtkMenuItem *Item, gpointer What)
{
	GtkWidget *About;
	const gchar *Authors[3] = {"Developer: Zatyagin Dmitry <Dimchikraph@tut.by>", NULL};
	
	About = gtk_about_dialog_new();
	gtk_about_dialog_set_logo(GTK_ABOUT_DIALOG(About), gdk_pixbuf_new_from_inline(-1, LOGO, FALSE, NULL));
	gtk_about_dialog_set_name(GTK_ABOUT_DIALOG(About), "");
	gtk_about_dialog_set_version(GTK_ABOUT_DIALOG(About), "0.2-alpha");
	gtk_about_dialog_set_comments(GTK_ABOUT_DIALOG(About), "GTK2 universal samba client");
	gtk_about_dialog_set_copyright(GTK_ABOUT_DIALOG(About), "Zatyagin Dmitry 2004-2006");
	gtk_about_dialog_set_authors(GTK_ABOUT_DIALOG(About), Authors);
	gtk_about_dialog_set_website(GTK_ABOUT_DIALOG(About), "http://sourceforge.net/projects/g2sc");
	gtk_dialog_run(GTK_DIALOG(About));
	gtk_widget_destroy(About);	
	return NULL;	
}
